
var cloudService = {
    makePostCall:function(sFunction,queryParameter,func,data) {

        lInfo.logln("http post reuqest " + sFunction + " with parameter " + queryParameter);
        lInfo.logln("body " + data);
        try {        
          var handle = new WebserviceConnection();
                  
          if (this.isNewWebrequest()) {
              handle.request(sFunction,
                  queryParameter+ '&dsid='+this.getMyDSID()+ '&dssid='+this.getMyDSID(),
                  'POST', 
                  {'Content-Type':'application/json','NotificationTextIsUrlEncodedUtf7':'true'},
                  data,
                  true, 
                  function(code, retdata) {
                    if (code === 200) {
                                //lInfo.logln( ': OK [' + code + ']');
                            } else {
                                lWarn.logln(': FAILED! Server replied: "' + code + '"');
                            }
                    //lInfo.logln(retdata);
                    func(JSON.parse(retdata));
                  });            
          } else {
            sFunction=sFunction+"?" + queryParameter + '&dsid='+this.getMyDSID() + '&dssid='+this.getMyDSID()+'&token='+this.getOSPToken();
              handle.request(sFunction, 'POST', {'Content-Type':'application/json','NotificationTextIsUrlEncodedUtf7':'true'},
                  data
                    , function(code, retdata) {
                    if (code === 200) {
                                //lInfo.logln( ': OK [' + code + ']');
                            } else {
                                lWarn.logln(': FAILED! Server replied: "' + code + '"');
                            }
                      //lInfo.logln(retdata);
                      func(JSON.parse(retdata));
                  });
          }

        } catch (e) {
            lWarn.logln("Exception during http post reuqest " + sFunction+": ");
            for (var i in e) {
                lWarn.logln(i + ': ' + e[i]);
            }
        }
    },
    makeGetCall:function(sFunction,queryParameter,func,options) {
        var extraheaders = [];

        lInfo.logln("http get reuqest " + sFunction + ' with parameter ' + queryParameter);
        try {
            if (options==null)
                options= { 'debug' : 0};
            else
                options.debug=0;
            
            var handle = new WebserviceConnection();
            
            lInfo.logln("http get reuqest " + sFunction +'?'+ queryParameter+ '&dsid='+this.getMyDSID()+ '&dssid='+this.getMyDSID());
            if (this.isNewWebrequest()) {
                handle.simplerequest(sFunction,queryParameter+ '&dsid='+this.getMyDSID()+ '&dssid='+this.getMyDSID(), 'GET',true, function(code, data) {
                    //lInfo.logln(data);
                    if (code === 200) {
                        //lInfo.logln( ': OK [' + code + ']');
                        func(JSON.parse(data));
                    } else {
                        lInfo.logln(': FAILED! Server replied: "' + code + '"');
                    }
                });          
          } else {
            sFunction=sFunction+"?" + queryParameter + '&dsid='+this.getMyDSID() + '&dssid='+this.getMyDSID()+'&token='+this.getOSPToken();
                handle.simplerequest(sFunction, 'GET', function(code, data) {
                    if (code === 200) {
                        //lInfo.logln( ': OK [' + code + ']');
                    } else {
                        lInfo.logln(': FAILED! Server replied: "' + code + '"');
                    }
                    lInfo.logln(data);
                    func(JSON.parse(data));
                });
          }
        } catch (e) {
            lWarn.logln("Error during upload: ");
            for (var i in e) {
                lWarn.logln(i + ': ' + e[i]);
            }
        }
    },      
    isRemoteConnectivityReady: function () {
      if (Property.getNode('/scripts/remote-connectivity/OSPToken') != null)
        return true;
      if (Property.getNode('/scripts/system-addon-remote-connectivity/OSPToken') != null)
        return true;
      return false;
    },
    isNewWebrequest:function() {
      return (Property.getNode('/scripts/system-addon-remote-connectivity/OSPToken') != null);
    },
    getOSPToken:function() {
      if (Property.getNode('/scripts/remote-connectivity/OSPToken') != null)
        return Property.getNode('/scripts/remote-connectivity/OSPToken').getValue();
      if (Property.getNode('/scripts/system-addon-remote-connectivity/OSPToken') != null)
        return Property.getNode('/scripts/system-addon-remote-connectivity/OSPToken').getValue();
      return null;
    },
    getCloudEmail:function() {
      if (Property.getNode('/scripts/remote-connectivity/username'))
        return Property.getNode('/scripts/remote-connectivity/username').getValue();
      if (Property.getNode('/scripts/system-addon-remote-connectivity/username'))
        return Property.getNode('/scripts/system-addon-remote-connectivity/username').getValue();
      return null;
    },
    getMyDSID:function(){
		  return Property.getProperty('/system/dSID');			
	  },
    getLanguage:function(){
      return Property.getProperty('/system/language/locale').replace('_','-'); 
      //return Property.getProperty('/system/language/locale');        
    },
    startService:function(func) {
      var sToken = this.getOSPToken();
      if (sToken != null) {
        var url='/public/service/v1_0/MediaLibrary/StartMediaService';
        this.makePostCall(url,"",func,"{}");
      }
    },
    createTextSound:function(sLang, sVoiceName, sText,func) {
    	var sGUIDFolder = Property.getProperty('media-service/t2SpeechBase');
    	
      var url='/public/service/v1_0/MediaLibrary/CreateVoiceFile';
      var parameter='serviceName=MediaService&serviceToken=2a24a321af65aef114a9&languageCode=' + sLang+"&text="+encodeURI(sText)+"&mediaLibraryPath="+sGUIDFolder+"&voiceId="+sVoiceName+"&returnVoiceFile=false";
      this.makePostCall(url,parameter,func,"{}");
      //this.fakeCreateFile(func);
    },
    deleteTextSound:function(sGUID,func) {
      var url='/public/service/v1_0/MediaLibrary/DeleteVoiceFile';
      var parameter='textToSpeechVoiceFileGuid='+sGUID;
      this.makeGetCall(url,parameter,func,"{}");
    },
    fetchText2SpeechConf:function(func) {
      var url='/public/service/v1_0/MediaLibrary/GetTextToSpeechConfiguration';
      var parameter='serviceName=MediaService';
      this.makeGetCall(url,parameter,func);
    },
    fetchMediaLibrary:function(func,sLanguage) {
      var sToken = this.getOSPToken();
      if (sToken != null) {
    	  if (sLanguage==null)
    		  sLanguage=this.getLanguage();
    	  else
    		  sLanguage=sLanguage.replace('_','-');
	        var url='/public/service/v1_0/MediaLibrary/GetMediaLibrary'
	        var parameter='includeMediaFileNames=true&languageCode='+sLanguage;
	        this.makeGetCall(url,parameter,func);
      }
    },
    fetchMediaFile:function(sFileID, func) {
      lInfo.logln("sFileID="+sFileID);
      var url='/public/service/v1_0/MediaLibrary/GetMediaFile';
      var parameter='mediaFileGuid='+sFileID+'&languageCode='+this.getLanguage();
      this.makeGetCall(url,parameter,func);
    },
    fetchMediaDefaultConfiguration:function(func) {
        var url='/public/service/v1_0/MediaLibrary/GetEventMediaFile';
        var parameter='language='+this.getLanguage();
        lInfo.logln('testLang' + parameter);
        this.makeGetCall(url,parameter,func);
    }
};