var LOGFILE_NAME = "sonos-controller.log";
var lWarn = {
	logln : function(o) {
	}
};
var lInfo = {
	logln : function(o) {
	}
};

Property.setSavedProperty = function(path, value) {
	Property.setProperty(path, value);
	Property.setFlag(path, 'ARCHIVE', true);
}

lInfo = new Logger(LOGFILE_NAME);
lWarn = new Logger(LOGFILE_NAME);

function getPlayerIPAdress(zoneID) {
	if (zoneID == null)
		return null;
	var oPlayerArray = Property.getNode('players').getChildren();
	for (var iIndex = 0; iIndex < oPlayerArray.length; iIndex++) {
		if (oPlayerArray[iIndex].getChild('zoneID') != null)
			if (oPlayerArray[iIndex].getChild('zoneID').getValue() == zoneID)
				if (oPlayerArray[iIndex].getChild('disabled').getValue() == false) {
					if (oPlayerArray[iIndex].getChild('coordinator').getValue())
						return oPlayerArray[iIndex].getChild('ip').getValue();
					else {
						var groupID = oPlayerArray[iIndex].getChild('group').getValue();
						for (var jIndex = 0; jIndex < oPlayerArray.length; jIndex++) {
							if (oPlayerArray[jIndex].getChild('group') == groupID)
								if (oPlayerArray[jIndex].getChild('coordinator').getValue())
									return oPlayerArray[jIndex].getChild('ip').getValue();
						}
					}
				}
	}
	return null;
}

function getFirstActiveIP() {
	var oPlayerArray = Property.getNode('players').getChildren();
	for (var iIndex = 0; iIndex < oPlayerArray.length; iIndex++) {
		if (oPlayerArray[iIndex].getChild('online').getValue()==true)
			if (oPlayerArray[iIndex].getChild('invisible').getValue()==false)
				return oPlayerArray[iIndex].getChild('ip').getValue();
	}
	return null;
}

if (raisedEvent.name == 'sonos.info') {
	if (raisedEvent.parameter.actions == 'getCurrentTitle') {
		if (raisedEvent.parameter.zoneID != null) {
			var sIP = getPlayerIPAdress(parseInt("" + raisedEvent.parameter.zoneID, 10));

			lInfo.logln("sonos.info getCurrentTitle for IP:" + sIP);

			var data = "";
			var objCurrentTrack = upnpGetCurrentTrack(sIP);
			if (objCurrentTrack != null) {
				data = JSON.stringify(objCurrentTrack);
				new Event("sonos.saved", {
					zoneID : raisedEvent.parameter.zoneID,
					actions : 'getCurrentTitle',
					value : data
				}).raise();
			} else {
				new Event("sonos.saved", {
					zoneID : raisedEvent.parameter.zoneID,
					actions : 'getCurrentTitle',
					value : 'error'
				}).raise();
			}
		}
	}
	if (raisedEvent.parameter.actions == 'getCurrentQueue') {
		if (raisedEvent.parameter.zoneID != null) {
			var sIP = getPlayerIPAdress(parseInt("" + raisedEvent.parameter.zoneID, 10));

			lInfo.logln("sonos.info getCurrentQueue for IP:" + sIP);

			var data = "";
			var arrayLists = upnpGetCurrentQueue(sIP);
			if (arrayLists != null) {
				data = JSON.stringify(arrayLists);
				lInfo.logln(data);

				new Event("sonos.saved", {
					zoneID : raisedEvent.parameter.zoneID,
					actions : 'getCurrentQueue',
					value : data
				}).raise();
				lInfo.logln('raised data');
			} else {
				new Event("sonos.saved", {
					zoneID : raisedEvent.parameter.zoneID,
					actions : 'getCurrentQueue',
					value : 'error'
				}).raise();
				lInfo.logln('raised data');
			}

		}
	}
	if (raisedEvent.parameter.actions == 'fetchSonosPlaylists') {
		lInfo.logln('fetchSonosPlaylists');
		Property.load();
		if (Property.getNode('players') != null) {
			var arrayLists = upnpGetSonosSavedPlaylists([getFirstActiveIP()]);
			lInfo.logln('ergebnis ' + arrayLists);
			Property.getNode('/scripts/sonos-controller').removeChild('playlists');
			if (arrayLists != null)
				for (var iIndex = 0; iIndex < arrayLists.length; iIndex++) {
					Property.setSavedProperty('playlists/' + iIndex + '/title', arrayLists[iIndex].title);
					Property.setSavedProperty('playlists/' + iIndex + '/url', arrayLists[iIndex].listCall);
					Property.setSavedProperty('playlists/' + iIndex + '/meta', arrayLists[iIndex].metaData);
				}
			Property.store();
		}
	}
	if (raisedEvent.parameter.actions == 'fetchSonosFavorites') {
		lInfo.logln('fetchSonosFavorites');
		Property.load();
		var arrayLists = upnpGetSonosFavorites(getFirstActiveIP());
		Property.getNode('/scripts/sonos-controller').removeChild('favorites');
		for (var iIndex = 0; iIndex < arrayLists.length; iIndex++) {
			Property.setSavedProperty('favorites/' + iIndex + '/title', arrayLists[iIndex].title);
			Property.setSavedProperty('favorites/' + iIndex + '/url', arrayLists[iIndex].listCall);
			Property.setSavedProperty('favorites/' + iIndex + '/meta', arrayLists[iIndex].metaData);
			Property.setSavedProperty('favorites/' + iIndex + '/singleTrack', arrayLists[iIndex].isSingleTrack);
		}
		Property.store();
	}
	if (raisedEvent.parameter.actions =='fetchSonosSettings') {
		lInfo.logln('fetchSonosFavorites');
		Property.load();
		if (Property.getNode('players') != null) {
			var arrayLists = upnpGetSonosFavorites(getFirstActiveIP());
			Property.getNode('/scripts/sonos-controller').removeChild('favorites');
			for (var iIndex = 0; iIndex < arrayLists.length; iIndex++) {
				Property.setSavedProperty('favorites/' + iIndex + '/title', arrayLists[iIndex].title);
				Property.setSavedProperty('favorites/' + iIndex + '/url', arrayLists[iIndex].listCall);
				Property.setSavedProperty('favorites/' + iIndex + '/meta', arrayLists[iIndex].metaData);
				Property.setSavedProperty('favorites/' + iIndex + '/singleTrack', arrayLists[iIndex].isSingleTrack);
			}
			
			arrayLists = upnpGetSonosSavedPlaylists([getFirstActiveIP()]);
			Property.getNode('/scripts/sonos-controller').removeChild('playlists');
			if (arrayLists != null)
				for (var iIndex = 0; iIndex < arrayLists.length; iIndex++) {
					Property.setSavedProperty('playlists/' + iIndex + '/title', arrayLists[iIndex].title);
					Property.setSavedProperty('playlists/' + iIndex + '/url', arrayLists[iIndex].listCall);
				}
			Property.store();
			new Event('sonos.saved',{actions:'sonosSettings'}).raise();
		}		
	}
}